<?php
/**
* @Package Tunnel to CPG
* @copyright (c) 2020 RJCreations
* @license http://opensource.org/licenses/GPL-3.0 GNU Public License Version 3
*/

namespace Drupal\cpgtunnel\Tunnel;

class CPGTunnel
{
	protected $udata;
	protected $config;
	const DL2CPG = 'drupal_2_cpg';

	public function __construct ($udata=null, $config=null)
	{
		$this->udata = $udata;
		$this->config = $config;
	}

	public function tunnel_open ()
	{
		global $user, $request, $config;

	//	$ugrps = explode(',', $user->data['group_id']);
	//	$agrps = explode(',', $config['ron4mac_tunneltocpg_groups']);
		$grpOk = TRUE;		//array_intersect($agrps, $ugrps);

		$usrn = $this->udata['uname'];
		$pass = $this->udata['upass'];
		$lift = ini_get('session.gc_maxlifetime');
		if ($grpOk && isset($usrn, $pass)) {
			$secret = $this->config->get('secret');
			$cookval = 'T2CPG'
				."\0".$usrn
				."\0".$pass
				."\0".$this->udata['email']
				."\0".$this->udata['lang']
				."\0".$lift
				."\0".$this->udata['uid']
				;
			$encrypt = $this->enCrypt($secret, $cookval, 'o');
			setcookie(self::DL2CPG, $encrypt, time() + $lift, '/');
		} else {
			// not alowed - clear any lingering cookie
			setcookie(self::DL2CPG, '', time()-3600, '/');
		}
	}

	public function tunnel_close ($account)
	{
		$uid = $account->id();
		if ($uid) {
			setcookie(self::DL2CPG, '', time() - 31622400, '/');
		}
	}

	private function enCrypt ($pass, $dat, $mth)
	{
		switch ($mth) {
			case 'm':
				return base64_encode($this->mc_crypt(false, $dat, $pass));
				break;
			case 'o':
			default:
				return $this->os_encrypt($dat, $pass);
				break;
		}
	}

	private function mc_crypt ($de, $dat, $pass)
	{
		$td = mcrypt_module_open(MCRYPT_3DES, '', MCRYPT_MODE_ECB, '');
		$iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($td), MCRYPT_DEV_RANDOM);
		$ks = mcrypt_enc_get_key_size($td);
		$key = substr($pass, 0, $ks);
		mcrypt_generic_init($td, $key, $iv);
		if ($de) { $retdat = trim(mdecrypt_generic($td, $dat)); }
		else { $retdat = mcrypt_generic($td, $dat); }
		mcrypt_generic_deinit($td);
		mcrypt_module_close($td);
		return $retdat;
	}

	const CIPHER = 'aes-256-ctr';

	private function os_encrypt ($message, $key)
	{
		$nonceSize = openssl_cipher_iv_length(self::CIPHER);
		$nonce = openssl_random_pseudo_bytes($nonceSize);
		$ciphertext = openssl_encrypt($message, self::CIPHER, $key, OPENSSL_RAW_DATA, $nonce);
		return base64_encode($nonce.$ciphertext);
	}

	private function os_decrypt ($message, $key)
	{
		$message = base64_decode($message);
		$nonceSize = openssl_cipher_iv_length(self::CIPHER);
		$nonce = mb_substr($message, 0, $nonceSize, '8bit');
		$ciphertext = mb_substr($message, $nonceSize, null, '8bit');
		$plaintext = openssl_decrypt($ciphertext, self::CIPHER, $key, OPENSSL_RAW_DATA, $nonce);
		return $plaintext;
	}

}
